/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/GUIForms/JFrame.java to edit this template
 */
package school.classes.forms;

import java.awt.Component;
import java.util.ArrayList;
import java.util.List;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JPanel;
import school.FormActions;
import school.classes.SchoolClass;
import school.classes.SchoolClassesService;
import school.students.Student;
import school.students.StudentsService;
import school.teachers.Teacher;
import school.teachers.TeachersService;

/**
 *
 * @author betinayy
 */
public class ClassesActions extends javax.swing.JFrame {
    
    private final SchoolClassesService classesService;
    private FormActions formAction;
    private SchoolClass selectedClass;
    private TeachersService teacherService;
    private StudentsService studentsService;

    /**
     * Creates new form ClassesForm
     */
    public ClassesActions() {
        initComponents();
        classesService = new SchoolClassesService();
        this.addStudent.setVisible(false);
        this.addTeacher.setVisible(false);
    }
    
    public ClassesActions(FormActions action) {
        initComponents();
        classesService = new SchoolClassesService();
        teacherService = new TeachersService();
        studentsService = new StudentsService();
        this.formAction = action;
        setTeachers();
        setStudents();
        this.addStudent.setVisible(false);
        this.addTeacher.setVisible(false);
        this.teachers.setVisible(false);
        this.students.setVisible(false);
        this.teachersLabel.setVisible(false);
        this.studentsLabel.setVisible(false);
    }
    
    public ClassesActions(FormActions action, SchoolClass schoolClass) {
        initComponents();
        classesService = new SchoolClassesService();
        this.formAction = action;
        this.selectedClass = schoolClass;
        setProperties();
        this.addStudent.setVisible(false);
        this.addTeacher.setVisible(false);
        this.save.setVisible(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jPanel1 = new javax.swing.JPanel();
        classNameLabel = new javax.swing.JLabel();
        className = new javax.swing.JTextField();
        gradeLabel = new javax.swing.JLabel();
        validLable = new javax.swing.JLabel();
        grade = new javax.swing.JTextField();
        valid = new javax.swing.JCheckBox();
        save = new javax.swing.JButton();
        panelHeading = new javax.swing.JLabel();
        teachers = new javax.swing.JComboBox<>();
        teachersLabel = new javax.swing.JLabel();
        studentsLabel = new javax.swing.JLabel();
        students = new javax.swing.JComboBox<>();
        backButton = new javax.swing.JButton();
        addTeacher = new javax.swing.JButton();
        addStudent = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setBackground(new java.awt.Color(0, 153, 153));

        jPanel1.setBackground(new java.awt.Color(0, 153, 153));

        classNameLabel.setForeground(new java.awt.Color(255, 255, 255));
        classNameLabel.setText("Class name");

        className.setText("jTextField1");
        className.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                classNameActionPerformed(evt);
            }
        });

        gradeLabel.setForeground(new java.awt.Color(255, 255, 255));
        gradeLabel.setText("Grade");

        validLable.setForeground(new java.awt.Color(255, 255, 255));
        validLable.setText("Valid");

        grade.setText("jTextField2");

        valid.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                validActionPerformed(evt);
            }
        });

        save.setText("Save");
        save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                saveActionPerformed(evt);
            }
        });

        panelHeading.setFont(new java.awt.Font("Tahoma", 0, 18)); // NOI18N
        panelHeading.setForeground(new java.awt.Color(255, 255, 255));
        panelHeading.setText("Class");


        teachersLabel.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        teachersLabel.setForeground(new java.awt.Color(255, 255, 255));
        teachersLabel.setText("Teachers");

        studentsLabel.setFont(new java.awt.Font("Tahoma", 0, 12)); // NOI18N
        studentsLabel.setForeground(new java.awt.Color(255, 255, 255));
        studentsLabel.setText("Students");

        students.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                studentsActionPerformed(evt);
            }
        });

        backButton.setText("Back");
        backButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                backButtonActionPerformed(evt);
            }
        });

        addTeacher.setText("Add teacher");
        addTeacher.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addTeacherActionPerformed(evt);
            }
        });

        addStudent.setText("Add student");
        addStudent.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addStudentActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(329, 329, 329)
                        .addComponent(panelHeading))
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGap(317, 317, 317)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(save, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .addComponent(backButton, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))))
                .addContainerGap(336, Short.MAX_VALUE))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                        .addComponent(classNameLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(gradeLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(validLable, javax.swing.GroupLayout.PREFERRED_SIZE, 63, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(teachersLabel)
                    .addComponent(studentsLabel))
                .addGap(52, 52, 52)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(grade)
                    .addComponent(className)
                    .addComponent(valid)
                    .addComponent(teachers, 0, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(students, javax.swing.GroupLayout.PREFERRED_SIZE, 135, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(38, 38, 38)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(addTeacher)
                    .addComponent(addStudent))
                .addGap(118, 118, 118))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(panelHeading, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(jPanel1Layout.createSequentialGroup()
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(className, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(classNameLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 28, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(34, 34, 34)
                        .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(grade, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(gradeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(32, 32, 32)
                        .addComponent(validLable, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(valid))
                .addGap(33, 33, 33)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(teachers, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(teachersLabel)
                    .addComponent(addTeacher))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 23, Short.MAX_VALUE)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(studentsLabel, javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(students, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(addStudent)))
                .addGap(35, 35, 35)
                .addComponent(backButton)
                .addGap(18, 18, 18)
                .addComponent(save)
                .addGap(34, 34, 34))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void studentsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_studentsActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_studentsActionPerformed

    private void saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_saveActionPerformed
        SchoolClass schoolClass;
        if (formAction.equals(FormActions.CREATE)) {
            save.setText("Create");
            schoolClass = new SchoolClass(valid.isEnabled(), Integer.parseInt(grade.getText()), className.getText());
            classesService.createSchoolClass(schoolClass);
        } else if (formAction.equals(FormActions.EDIT)) {
            save.setText("Update");
            this.selectedClass.setClassName(className.getText());
            this.selectedClass.setGrade(Integer.parseInt(grade.getText()));
            this.selectedClass.setValid(valid.isEnabled());
            classesService.updateSchoolClass(this.selectedClass);
        }
    }//GEN-LAST:event_saveActionPerformed

    private void classNameActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_classNameActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_classNameActionPerformed

    private void validActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_validActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_validActionPerformed

    private void backButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_backButtonActionPerformed
        JFrame classesPanel = new ClassesForm();
        classesPanel.setVisible(true);
        dispose();
    }//GEN-LAST:event_backButtonActionPerformed

    private void addTeacherActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addTeacherActionPerformed
        Teacher teacher = (Teacher) this.teachers.getSelectedItem();
        if (!this.selectedClass.getTeachers().contains(teacher)) {
            this.selectedClass.getTeachers().add(teacher);
            this.selectedClass.setTeachers(this.selectedClass.getTeachers());
        }
    }//GEN-LAST:event_addTeacherActionPerformed

    private void addStudentActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addStudentActionPerformed
        Student student = (Student) this.students.getSelectedItem();
        if (!this.selectedClass.getStudents().contains(student)) {
            this.selectedClass.getStudents().add(student);
            this.selectedClass.setStudents(this.selectedClass.getStudents());
        }
    }//GEN-LAST:event_addStudentActionPerformed
    
    private void setProperties() {
        this.className.setText(this.selectedClass.getClassName());
        this.grade.setText(this.selectedClass.getGrade().toString());
        this.valid.setSelected(this.selectedClass.getValid());
        setTeachers();
        setStudents();
        this.addStudent.setVisible(false);
        this.addTeacher.setVisible(false);
    }
    
    private void setTeachers() {
        List<Teacher> teachers = new ArrayList<>();
        if (this.selectedClass != null) {
            teachers = this.selectedClass.getTeachers();
            
        } else {
//            teachers = this.teacherService.getTeachers();
        }
        if (!teachers.isEmpty()) {
            for (Teacher teacher : teachers) {
                this.teachers.addItem(teacher);
            }
            
            this.teachers.setSelectedIndex(0);
            initTeacherCombobox();
        }
    }
    
    private void setStudents() {
        List<Student> students = new ArrayList<>();

        if (this.selectedClass != null) {
            students = this.selectedClass.getStudents();

        } else {
//            students = this.studentsService.getStudents();
        }
        if (!students.isEmpty()) {
            for (Student student : students) {
                this.students.addItem(student);
            }
            this.students.setSelectedIndex(0);
            initStudentCombobox();
        }
    }
    
    private void initTeacherCombobox() {
        this.teachers.setRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
                
                Teacher person = (Teacher) value;
                StringBuilder sb = new StringBuilder();
                sb.append(person.getFirstName()).append(" ").append(person.getLastName());
                setText(sb.toString());
                return this;
            }
        });
    }
    
    private void initStudentCombobox() {
        this.students.setRenderer(new DefaultListCellRenderer() {
            @Override
            public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus) {
                super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
                
                Student person = (Student) value;
                StringBuilder sb = new StringBuilder();
                sb.append(person.getFirstName()).append(" ").append(person.getLastName());
                setText(sb.toString());
                return this;
            }
        });
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(ClassesActions.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(ClassesActions.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(ClassesActions.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(ClassesActions.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new ClassesActions().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addStudent;
    private javax.swing.JButton addTeacher;
    private javax.swing.JButton backButton;
    private javax.swing.JTextField className;
    private javax.swing.JLabel classNameLabel;
    private javax.swing.JTextField grade;
    private javax.swing.JLabel gradeLabel;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel panelHeading;
    private javax.swing.JButton save;
    private javax.swing.JComboBox<Student> students;
    private javax.swing.JLabel studentsLabel;
    private javax.swing.JComboBox<Teacher> teachers;
    private javax.swing.JLabel teachersLabel;
    private javax.swing.JCheckBox valid;
    private javax.swing.JLabel validLable;
    // End of variables declaration//GEN-END:variables

}
